/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER         "0.1"
#define GOODFTPDATA "048566449372936045438395835337530293447"



int main(int argc, char *argv[]) {
    char    *out,
            *pwd;
    int     i,
            len,
            tmp;


    setbuf(stdout, NULL);

    fputs("\n"
        "Good FTP password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <password>\n"
            "\n"
            "The password of the accounts are stored in the binary file called Goodftp.lsd\n"
            "I'm lazy so I have build only this simple decoder, you must manually get the\n"
            "password from the file (it is simple, search the username with an hex editor\n"
            "and after 4 bytes you find the encoded password)\n"
            "\n", argv[0]);
        exit(1);
    }

    out = pwd = argv[1];
    len = strlen(pwd) >> 1;
    for(i = 0; i < len; i++) {
        sscanf(pwd, "%02X", &tmp);
        *out++ = tmp;
        pwd += 2;
    }

    out = pwd = argv[1];
    for(i = 0; i < len; i++) {
        *out++ = *pwd++ ^ GOODFTPDATA[i];
    }
    *out = 0;

    printf("\nPassword:   %s\n", argv[1]);

    return(0);
}


